=== debian/changelog ===
ardour (1:5.0~dfsg-2) unstable; urgency=medium

  [ Jaromír Mikeš ]
  * Update copyright file.
  * Exclude some more files on repack.
  * Add spelling patch.
  * Add entry to overrides file.

  [ Kaj Ailomaa ]
  * Fix conlict between ardour and ardour-data (Closes: #834488)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 21 Aug 2016 21:06:52 +0200

ardour (1:5.0~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 5.0~dfsg

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Mon, 15 Aug 2016 10:24:34 +0200

ardour (1:4.7~dfsg-2) unstable; urgency=medium

  * Add .gitignore file.
  * Add patch to build with gcc6. (Closes: #831133)
  * Bump Standards.
  * Fix VCS fields.
  * Fix hardening.
  * Build-dep dh 9.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 27 Jul 2016 15:31:34 +0200
