=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/ardour-$1\.tar\.gz/,uversionmangle=s/-pre/~pre/;s/-rc/~rc/,dversionmangle=s/~dfsg.*// \
  https://github.com/Ardour/ardour/tags .*/v?(\d\S*)\.tar\.gz
